use std::sync::Arc;

use async_trait::async_trait;
use como_domain::projects::{
    queries::{GetProjectQuery, GetProjectsQuery},
    ProjectDto,
};

pub type DynProjectService = Arc<dyn ProjectService + Send + Sync>;

#[async_trait]
pub trait ProjectService {
    async fn get_project(&self, query: GetProjectQuery) -> anyhow::Result<ProjectDto>;
    async fn get_projects(&self, query: GetProjectsQuery) -> anyhow::Result<Vec<ProjectDto>>;
}
